• LeetCode Median of Two Sorted Arrays


    Median of Two Sorted Arrays

    There are two sorted arrays A and B of size m and n respectively. Find the median of the two sorted arrays. The overall run time complexity should be O(log (m+n)).

    思路:

    1、首先肯定是二分

    2、怎么二分?用k=(m+n)/2, 然后用k/2进行二分。再边界处理

    我们可以考虑从k入手。如果我们每次都能够剔除一个一定在第k大元素之前的元素,那么我们需要进行k次。但是如果每次我们都剔除一半呢?所以用这种类似于二分的思想,我们可以这样考虑:

    Assume that the number of elements in A and B are both larger than k/2, and if we compare the k/2-th smallest element in A(i.e. A[k/2-1]) and the k-th smallest element in B(i.e. B[k/2 - 1]), there are three results:
    (Becasue k can be odd or even number, so we assume k is even number here for simplicy. The following is also true when k is an odd number.)
    A[k/2-1] = B[k/2-1]
    A[k/2-1] > B[k/2-1]
    A[k/2-1] < B[k/2-1]
    if A[k/2-1] < B[k/2-1], that means all the elements from A[0] to A[k/2-1](i.e. the k/2 smallest elements in A) are in the range of k smallest elements in the union of A and B. Or, in the other word, A[k/2 - 1] can never be larger than the k-th smalleset element in the union of A and B.

    Why?
    We can use a proof by contradiction. Since A[k/2 - 1] is larger than the k-th smallest element in the union of A and B, then we assume it is the (k+1)-th smallest one. Since it is smaller than B[k/2 - 1], then B[k/2 - 1] should be at least the (k+2)-th smallest one. So there are at most (k/2-1) elements smaller than A[k/2-1] in A, and at most (k/2 - 1) elements smaller than A[k/2-1] in B.So the total number is k/2+k/2-2, which, no matter when k is odd or even, is surly smaller than k(since A[k/2-1] is the (k+1)-th smallest element). So A[k/2-1] can never larger than the k-th smallest element in the union of A and B if A[k/2-1]<B[k/2-1];
    Since there is such an important conclusion, we can safely drop the first k/2 element in A, which are definitaly smaller than k-th element in the union of A and B. This is also true for the A[k/2-1] > B[k/2-1] condition, which we should drop the elements in B.
    When A[k/2-1] = B[k/2-1], then we have found the k-th smallest element, that is the equal element, we can call it m. There are each (k/2-1) numbers smaller than m in A and B, so m must be the k-th smallest number. So we can call a function recursively, when A[k/2-1] < B[k/2-1], we drop the elements in A, else we drop the elements in B.


    We should also consider the edge case, that is, when should we stop?
    1. When A or B is empty, we return B[k-1]( or A[k-1]), respectively;
    2. When k is 1(when A and B are both not empty), we return the smaller one of A[0] and B[0]
    3. When A[k/2-1] = B[k/2-1], we should return one of them

    code

        public double findMedianSortedArrays(int A[], int B[]) {
            int total = A.length + B.length;
            if (total%2 == 1)
                return search(A, B, total/2+1);
            else 
                return (search(A, B, total/2) + 
                        search(A, B, total/2+1))/2;
        }
        
        private double search(int A[], int B[], int k) {
            int m = A.length, n = B.length;
            if (m > n) return search(B, A, k);
            if (m == 0) return B[k-1];
            if (k == 1) return Math.min(A[0], B[0]);
            int pa = Math.min(k/2, m), pb = k-pa;
            if (A[pa-1] < B[pb-1]) 
                return search(Arrays.copyOfRange(A, pa, m), B, k-pa);
            else if (A[pa-1] > B[pb-1])
                return search(A, Arrays.copyOfRange(B, pb, n), k-pb);
            else 
                return A[pa-1];
        }
  • 相关阅读:
    SEM关键词的三种分类方式
    分分钟解决 MySQL 查询速度慢与性能差
    为什么notify(), wait()等函数定义在Object中,而不是Thread中
    wait(), notify(), notifyAll()等方法介绍
    Java中的Volatile和synchronized的区别
    史上最简单的 SpringCloud 教程
    如何用git将项目代码上传到github
    常见排序
    【CodeForces】9B-Running Student
    【CodeForces】9A-Die Roll
  • 原文地址:https://www.cnblogs.com/549294286/p/3679297.html
Copyright © 2020-2023  润新知